<?php

/**
* 01/06/2015
* @author Gabriel@Silva
*/

namespace Teknisa\DF\Factories;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\Remote\FileUploader\Server as fileUploader;

class Ger40100IntegracaoViaEmailFactory {
    
    protected $entityManager;
    protected $fileUploader;
    protected $environment;

    public function __construct(EntityManager $entityManager, $environment, $fileUploader) {
        $this->entityManager = $entityManager;
        $this->environment   = $environment;
        $this->fileUploader  = $fileUploader;
        set_time_limit(0);
    }	

    public function verificaIntegracaoViaEmail($DSSERVEMAIL, $DSLOGINEMAIL) {
        $sql = "SELECT count(*) AS NRREGS
                  FROM INTG_VIAEMAIL
                 WHERE DSSERVEMAIL =  :P_DSSERVEMAIL
                   AND DSLOGINEMAIL = :P_DSLOGINEMAIL";
                     
        $params = array(
            "P_DSSERVEMAIL" => $DSSERVEMAIL,
            "P_DSLOGINEMAIL" => $DSLOGINEMAIL
        );

	    $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }

    public function retornaTodosEmails($row) {
        $sql = "SELECT * FROM INTG_VIAEMAIL";

    	$std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function alteraIntgViaEmail($DSSERVEMAIL, $DSLOGINEMAIL, $CDSENHAEMAIL, $NRPORTAEMAIL, $IDUTTLSEMAIL, $IDUTSSLEMAIL, $NRPERIODEMAIL, $DSARQEXTENSAO, $DIRPHP, $JENKINSPATH, $CALLSERVPATH) {
        $sql = " UPDATE INTG_VIAEMAIL SET
                    	 CDSENHAEMAIL = :CDSENHAEMAIL,
                    	 NRPORTAEMAIL = :NRPORTAEMAIL,
                    	 IDUTTLSEMAIL = :IDUTTLSEMAIL,
                    	 IDUTSSLEMAIL = :IDUTSSLEMAIL,
                    	 NRPERIODEMAIL = :NRPERIODEMAIL,
                    	 DSARQEXTENSAO = :DSARQEXTENSAO,
                    	 DIRPHP = :DIRPHP,
                    	 JENKINSPATH = :JENKINSPATH,
                    	 CALLSERVPATH = :CALLSERVPATH 
                   WHERE DSSERVEMAIL = :DSSERVEMAIL
                     AND DSLOGINEMAIL = :DSLOGINEMAIL ";

        $params = array(
            "DSSERVEMAIL"=>$DSSERVEMAIL,
            "DSLOGINEMAIL"=>$DSLOGINEMAIL,
            "CDSENHAEMAIL"=>$CDSENHAEMAIL,
            "NRPORTAEMAIL"=>$NRPORTAEMAIL,
            "IDUTTLSEMAIL"=>$IDUTTLSEMAIL,
            "IDUTSSLEMAIL"=>$IDUTSSLEMAIL,
            "NRPERIODEMAIL"=>$NRPERIODEMAIL,
            "DSARQEXTENSAO"=>'XML',
            "DIRPHP"=>$DIRPHP,
            "JENKINSPATH"=>$JENKINSPATH,
            "CALLSERVPATH"=>$CALLSERVPATH
        );
    
	    $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
    }
    
    public function insereIntgViaEmail($DSSERVEMAIL, $DSLOGINEMAIL, $CDSENHAEMAIL, $NRPORTAEMAIL, $IDUTTLSEMAIL, $IDUTSSLEMAIL, $NRPERIODEMAIL, $DSARQEXTENSAO, $DIRPHP, $JENKINSPATH, $CALLSERVPATH) {
        $sql = " INSERT INTO INTG_VIAEMAIL 
                   ( DSSERVEMAIL,
                	 DSLOGINEMAIL,
                	 CDSENHAEMAIL,
                	 NRPORTAEMAIL,
                	 IDUTTLSEMAIL,
                	 IDUTSSLEMAIL,
                	 NRPERIODEMAIL,
                	 DSARQEXTENSAO,
                	 DIRPHP,
                	 JENKINSPATH,
                	 CALLSERVPATH 
                   ) VALUES ( 
                		 :DSSERVEMAIL,
                		 :DSLOGINEMAIL,
                		 :CDSENHAEMAIL,
                		 :NRPORTAEMAIL,
                		 :IDUTTLSEMAIL,
                		 :IDUTSSLEMAIL,
                		 :NRPERIODEMAIL,
                		 :DSARQEXTENSAO,
                		 :DIRPHP,
                		 :JENKINSPATH,
                		 :CALLSERVPATH 
                   )";

        $params = array(
            "DSSERVEMAIL"=>$DSSERVEMAIL,
            "DSLOGINEMAIL"=>$DSLOGINEMAIL,
            "CDSENHAEMAIL"=>$CDSENHAEMAIL,
            "NRPORTAEMAIL"=>$NRPORTAEMAIL,
            "IDUTTLSEMAIL"=>$IDUTTLSEMAIL,
            "IDUTSSLEMAIL"=>$IDUTSSLEMAIL,
            "NRPERIODEMAIL"=>$NRPERIODEMAIL,
            "DSARQEXTENSAO"=>'XML',
            "DIRPHP"=>$DIRPHP,
            "JENKINSPATH"=>$JENKINSPATH,
            "CALLSERVPATH"=>$CALLSERVPATH
        );
        
    	$std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
    }
        
    public function setAgendamentoIntegracaoEmail($nrorg, $useVpd, $newEntityManager, $newFileUploader) {
        if($useVpd)    $this->entityManager = $newEntityManager;
        if($nrorg > 1) $this->fileUploader  = $newFileUploader;
        
        $this->environment->setNrOrg($nrorg);
        $this->environment->setNrOrgTrab($nrorg);
        $this->environment->setCurrentUserId('AUTOMATICO');
    }
    
    /**
     * zGravaFile
     * Grava os dados no diretorio das NFe
     *
     * @param  string $tpAmb     ambiente
     * @param  string $filename  nome do arquivo
     * @param  string $data      dados a serem salvos
     * @param  string $subFolder
     * @param  string $chNFe
     * @throws Exception\RuntimeException
     */
    public function zGravaFile(
        $tpAmb = '2',
        $filename = '',
        $data = '',
        $subFolder = 'temporarias',
        $chNFe = ''
    ) {
        $tmpFile = sys_get_temp_dir().DIRECTORY_SEPARATOR.'xmlNota'.uniqid().'.xml';
        file_put_contents($tmpFile, $data);
        $file = file_get_contents($tmpFile);
        $file    = base64_encode($file);

        $file = 'data: '.mime_content_type($tmpFile).';base64,'.$file;
        $lastModify = filectime($tmpFile);

        $file = [
            "name" => $filename, 
            "lastModified" => $lastModify,
            "lastModifiedDate" => '',
            "webkitRelativePath" => '',
            "type" => '',
            "size"  => filesize($tmpFile),
            "b64File" => $file];
            
        $row['XML']    = [];
        $row['XML'][0] = $file;
        
        $subFolder .= date("Ym");
        $this->fileUploader->uploadFilesInRow($row, 'XML', $subFolder);
        unlink($tmpFile);
        
        $fileServerLink = $row['XML'][0]['path'];
        
        $subFolder = ($tpAmb == 1) ? 'producao/'.$subFolder : 'homologacao/'.$subFolder;
        
        $this->insertIntoRelacFileServer($chNFe, $subFolder, $fileServerLink);
        
        return $row['XML'][0]['path'];
    }
    
    private function insertIntoRelacFileServer($chNFe, $diretorio, $fileServerLink) {
        $sql = "INSERT
                INTO RELACFILESERVER
                   (CDRELAC,
                    DIRETORIO,
                    FILESERVERLINK,
                    NRORG)
                  VALUES
                   (:CDRELAC,
                    :DIRETORIO,
                    :FILESERVERLINK,
                    :NRORG)";
        
        $params = [
            "CDRELAC"        => $chNFe,
            "DIRETORIO"      => $diretorio,
            "FILESERVERLINK" => $fileServerLink,
            "NRORG"          => $this->environment->getNrOrgTrab()];

        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
    }
    
}
