<?php
namespace Teknisa\DF\Modules\Relatorios\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

use Zeedhi\Framework\Report\ReportService;

class Adm03000ReDeNotasFiscais extends \Zeedhi\Framework\Controller\Report{

    protected $Adm03000Service;
    protected $reportMapping = array(
        'ADM03000' => array(
            'strategy' => "BIRT",
            'parameterMapping' => array(
                'CDALMOXARIFE'=> "CDALMOXARIFE",
                'TAMNVTOT'=> "TAMNVTOT",
                'DATARE'=> "DATARE",
                'CDLOCALESTOQ'=> "CDLOCALESTOQ",
                'NRORG'=> "NRORG",
                'CDFILIAL'=> "CDFILIAL",
                'IDENTRSAID'=> "IDENTRSAID",
                'IDRETIICMS'=> "IDRETIICMS",
                'SALDOANT'=> "SALDOANT",
                'TOTENTR'=> "TOTENTR",
                'TOTSAID'=> "TOTSAID"
            )
        ),
        'ADM03001' => array(
            'strategy' => "BIRT",
            'parameterMapping' => array(
                'CDALMOXARIFE'=> "CDALMOXARIFE",
                'TAMNVTOT'=> "TAMNVTOT",
                'DATARE'=> "DATARE",
                'CDLOCALESTOQ'=> "CDLOCALESTOQ",
                'NRORG'=> "NRORG",
                'CDFILIAL'=> "CDFILIAL",
                'IDENTRSAID'=> "IDENTRSAID",
                'IDRETIICMS'=> "IDRETIICMS",
                'SALDOANT'=> "SALDOANT",
                'TOTENTR'=> "TOTENTR",
                'TOTSAID'=> "TOTSAID"
            )
        )
    );

	public function __construct($reportService, $Adm03000Service){
        parent::__construct($reportService);
        $this->Adm03000Service = $Adm03000Service;
	}

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();

        $this->Adm03000Service->verificaNumeracaoRe($row['CDFILIAL']);
        if($row['__report_name'] === 'ADM03000'){
            $this->Adm03000Service->verificaCapaDocumento('F', $row['CDALMOXARIFE'], $row['DATARE'], $row['CDLOCALESTOQ'], $row['CDFILIAL'], $row['IDENTRSAID']);
        } else {
            $this->Adm03000Service->verificaCapaDocumento('C', $row['CDALMOXARIFE'], $row['DATARE'], $row['CDLOCALESTOQ'], $row['CDFILIAL'], $row['IDENTRSAID']);
        }
    }

}